#!/bin/sh

#
# example.sh - get the last full day's worth of logs from a flat syslog
#              file and feed to toptalkers.awk
#
#              Actually: we get TODAY'S logs, so this needs to be run
#              just BEFORE midnight to capture "most" of what happened
#              during the day.  The script doesn't need to finish 
#              before midnight; it just needs to _start_ before midnight.
#
# NOTE THAT TOPTALKERS.AWK REQUIRES GAWK v3.1 or newer
#

# Which log file do we examine?
logfile=/var/log/firewall

# What interface do you want statistics for?
iface=int

# How many top talkers do you want to list?
topnum=10

# What do you want to display? Connections, Received, Sent and/or Data totals? 
# User names? Per-port statistics?
set display=crsdup


# Format a date string like the standard BSD syslog daemon does.
now=`date '+%b %e'`;
echo Analyzing '"'$now'"' from $logfile...

# Extract today's records from log file and hand to toptalkers.awk
grep "^$now .*FW:.*conn=close" $logfile | gawk -f toptalkers.awk $iface $topnum $display

